-- This is a player context script for MoO2 1.50 patch project.
--
-- This script shows you which techs your opponents have and you don't. It shows
-- only opponents in contact and only if /noreport option is off. It brings up a
-- message box for each opponent who has something.
--
-- To run the script press 1 in main screen (the file should be named MAIN1.LUA)

if get_conf("/noreport") == 1 then
    msgbox("/noreport option prevents tech check")
    return
end

c = get_current_player_id()
ct = get_player_techs(c)
shown = 0
for i,p in pairs(get_players()) do
    if i ~= c and p ~= nil then
        local out = ""
        local tt = get_player_techs(i)
        local found = {}
        if tt ~= nil then
            for t,status in pairs(tt) do
                if status == 3 and ct[t] ~= 3 then
                    table.insert(found, t)
                end
            end
        end
        if #found > 0 then
            shown = 1
            table.sort(found)
            local step = 20
            for j = 1, #found, step do
                local o = p.race .. " tech unknown to us:\n\n"
                for k = j, j + step -1 do
                    if k <= #found then
                        o = o .. found[k] .. "\n"
                    end
                end
                if #found > step then
                    o = o .. "\n(page " .. (j / step + 1) .. "/" .. (#found / step + 1) .. ")"
                end
                msgbox(o)
            end
        end
    end
end
if shown == 0 then
    msgbox("No race in contact has tech unknown to us")
end
